' @(#)69  1.2  src/hc/client/collectors/C/vbs/bitLocker.vbs, hc.collectors.win, scmweb, 080808a  8/8/08  05:48:48
'
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2008.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'------------------------------------------------------------

Option Explicit

Dim sDriveLetter
Dim WshShell,WshSysEnv

Set WshShell = WScript.CreateObject("WScript.Shell")
Set WshSysEnv = WshShell.Environment("PROCESS")

sDriveLetter = Left(WshSysEnv("SYSTEMDRIVE"),2)

WScript.Echo "[GlobalInfo]"
WScript.Echo "g_systemDrive=" & sDriveLetter

Dim strComputer
strComputer = "."

Dim objWMIService
Dim volumesSet
Dim volume

Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\ROOT\CIMV2\Security\MicrosoftVolumeEncryption")

Set volumesSet = objWMIService.InstancesOf("Win32_EncryptableVolume")

For Each volume In volumesSet

    Dim DeviceID
    Dim PersistentVolumeID
    Dim DriveLetter
    DeviceID = volume.DeviceID
    PersistentVolumeID = volume.PersistentVolumeID
    DriveLetter = volume.DriveLetter

    Dim GetConversionStatusReturn
    Dim ConversionStatus
    Dim EncryptionPercentage
    GetConversionStatusReturn = volume.GetConversionStatus(ConversionStatus, EncryptionPercentage)

    Dim GetEncryptionMethodReturn
    Dim EncryptionMethod
    GetEncryptionMethodReturn = volume.GetEncryptionMethod(EncryptionMethod)

    Dim GetProtectionStatusReturn
    Dim ProtectionStatus
    GetProtectionStatusReturn = volume.GetProtectionStatus(ProtectionStatus)

    Dim GetLockStatusReturn
    Dim LockStatus
    GetLockStatusReturn = volume.GetLockStatus(LockStatus)

    Dim IsAutoUnlockEnabledReturn
    Dim IsAutoUnlockEnabled
    Dim AutoUnlockVolumeKeyProtectorID
    IsAutoUnlockEnabledReturn = volume.IsAutoUnlockEnabled(IsAutoUnlockEnabled, AutoUnlockVolumeKeyProtectorID)

    Dim IsAutoUnlockKeyStoredReturn
    Dim IsAutoUnlockKeyStored
    IsAutoUnlockKeyStoredReturn = volume.IsAutoUnlockKeyStored(IsAutoUnlockKeyStored)

    Dim IsKeyProtectorAvailableReturn
    Dim IsKeyProtectorAvailable
    IsKeyProtectorAvailableReturn = volume.IsKeyProtectorAvailable(0, IsKeyProtectorAvailable)

    Dim GetHardwareTestStatusReturn
    Dim TestStatus
    Dim TestError
    GetHardwareTestStatusReturn = volume.GetHardwareTestStatus(TestStatus, TestError)

    WScript.Echo "[Volume]"
    WScript.Echo "v_volume=" & DriveLetter
    WScript.Echo "v_getConversionStatusReturn=" & GetConversionStatusReturn
    WScript.Echo "v_conversionStatus=" & ConversionStatus
    WScript.Echo "v_encryptionPercentage=" & EncryptionPercentage
    WScript.Echo "v_getEncryptionMethodReturn=" & GetEncryptionMethodReturn
    WScript.Echo "v_encryptionMethod=" & EncryptionMethod
    WScript.Echo "v_getProtectionStatusReturn=" & GetProtectionStatusReturn
    WScript.Echo "v_protectionStatus=" & ProtectionStatus
    WScript.Echo "v_getLockStatusReturn=" & GetLockStatusReturn
    WScript.Echo "v_lockStatus=" & LockStatus
    WScript.Echo "v_isAutoUnlockEnabledReturn=" & IsAutoUnlockEnabledReturn
    WScript.Echo "v_isAutoUnlockEnabled=" & IsAutoUnlockEnabled
    WScript.Echo "v_autoUnlockVolumeKeyProtectorID=" & AutoUnlockVolumeKeyProtectorID
    WScript.Echo "v_isAutoUnlockKeyStoredReturn=" & IsAutoUnlockKeyStoredReturn
    WScript.Echo "v_isAutoUnlockKeyStored=" & IsAutoUnlockKeyStored
    WScript.Echo "v_isKeyProtectorAvailableReturn=" & IsKeyProtectorAvailableReturn
    WScript.Echo "v_isKeyProtectorAvailable=" & IsKeyProtectorAvailable
    WScript.Echo "v_getHardwareTestStatusReturn=" & GetHardwareTestStatusReturn
    WScript.Echo "v_testStatus=" & TestStatus
    WScript.Echo "v_testError=" & TestError

    Dim GetKeyProtectorsReturn
    Dim ProtectorsIds
    GetKeyProtectorsReturn = volume.GetKeyProtectors(0, ProtectorsIds)

    WScript.Echo "v_getKeyProtectorsReturn=" & GetKeyProtectorsReturn

    If GetKeyProtectorsReturn = 0 Then

        Dim ProtectorId
        For Each ProtectorId In ProtectorsIds

            Dim GetKeyProtectorTypeReturn
            Dim KeyProtectorType
            GetKeyProtectorTypeReturn = volume.GetKeyProtectorType(ProtectorId, KeyProtectorType)

            Dim GetKeyProtectorFriendlyNameReturn
            Dim FriendlyName
            GetKeyProtectorFriendlyNameReturn = volume.GetKeyProtectorFriendlyName(ProtectorId, FriendlyName)

            Dim GetExternalKeyFileNameReturn
            Dim FileName
            GetExternalKeyFileNameReturn = volume.GetExternalKeyFileName(ProtectorId, FileName)

            'Dim GetKeyProtectorPlatformValidationProfileReturn
            'Dim PlatfValidProfile
            'GetKeyProtectorPlatformValidationProfileReturn = volume.GetKeyProtectorPlatformValidationProfile(ProtectorId, PlatfValidProfile)

            WScript.Echo
            WScript.Echo("[Protector]")
            WScript.Echo "p_volume=" & DriveLetter
            WScript.Echo("p_id=" & ProtectorId)
            WScript.Echo("p_getKeyProtectorTypeReturn=" & GetKeyProtectorTypeReturn)
            WScript.Echo("p_keyProtectorType=" & KeyProtectorType)
            WScript.Echo("p_getKeyProtectorFriendlyNameReturn=" & GetKeyProtectorFriendlyNameReturn)
            WScript.Echo("p_friendlyName=" & FriendlyName)
            WScript.Echo("p_getExternalKeyFileNameReturn=" & GetExternalKeyFileNameReturn)
            WScript.Echo("p_fileName=" & FileName)
            'WScript.Echo("p_getKeyProtectorPlatformValidationProfileReturn=" & GetKeyProtectorPlatformValidationProfileReturn)
            'WScript.Echo("platformValidationProfile=" & Join(PlatfValidProfile))

        Next

    End If

    WScript.Echo

Next
